EternalKingdom/src/Entity/City.php
<?php

namespace App\Entity;

use App\Entity\World\WorldMapNode;
use App\Repository\CityRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Doctrine\ORM\Mapping\OrderBy;

/**
 * @ORM\Entity(repositoryClass=CityRepository::class)
 */
class City implements \JsonSerializable
{
    /**
     * @ORM\Id
     *
     * @ORM\GeneratedValue
     *
     * @ORM\Column(type="integer")
     */
    private int $id;

    /**
     * @ORM\OneToOne(targetEntity=Lord::class, inversedBy="city", cascade={"persist", "remove"})
     *
     * @ORM\JoinColumn(nullable=false)
     */
    private Lord $lord;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private string $grid = '';

    /**
     * @ORM\Column(type="smallint")
     */
    private int $remainingTurns = 100;

    /**
     * @ORM\Column(type="smallint")
     */
    private int $wastedTurns = 0;

    /**
     * @ORM\OneToMany(targetEntity=Storage::class, mappedBy="city", cascade={"persist", "remove"})
     */
    private Collection $storages;

    /**
     * @ORM\OneToMany(targetEntity=BuiltBuildings::class, mappedBy="city", cascade={"persist", "remove"})
     *
     * @OrderBy({"id" = "ASC"})
     */
    private Collection $builtBuildings;

    /**
     * @ORM\Column(type="boolean")
     */
    private bool $recruiting = true;

    /**
     * @ORM\ManyToOne(targetEntity=Constructions::class)
     *
     * @ORM\JoinColumn(nullable=true)
     */
    private ?Constructions $constructionProject = null;

    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    private ?int $projectLevel = null;

    /**
     * @ORM\ManyToOne(targetEntity=WorldMapNode::class, cascade={"persist"})
     *
     * @ORM\JoinColumn(nullable=true)
     */
    private ?WorldMapNode $node = null;

    /**
     * That's the default army where the soldier spawns when aligning swords in the grid.
     *
     * @ORM\OneToOne(targetEntity=ArmyContainer::class, cascade={"persist", "remove"})
     *
     * @ORM\JoinColumn(nullable=false)
     */
    private ArmyContainer $defense;

    // City population info

    /**
     * @ORM\Column(type="smallint")
     */
    private int $dungeonLevel = 1;

    /**
     * @ORM\Column(type="smallint")
     */
    private int $housesCount = 0;

    public function __construct()
    {
        $this->storages = new ArrayCollection();
        $this->builtBuildings = new ArrayCollection();
        $this->defense = new ArmyContainer();
    }

    #[\Override]
    public function jsonSerialize(): array
    {
        return [
            'locationName' => $this->node->getData()->getName(),
            'towerLevel' => $this->dungeonLevel,
            'nbHouses' => $this->housesCount,
        ];
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getName(): ?string
    {
        return $this->node->getName();
    }

    public function getLord(): Lord
    {
        return $this->lord;
    }

    public function setLord(Lord $lord): self
    {
        $this->lord = $lord;

        return $this;
    }

    public function getGrid(): ?string
    {
        return $this->grid;
    }

    public function setGrid(string $grid): self
    {
        $this->grid = $grid;

        return $this;
    }

    public function getRemainingTurns(): ?int
    {
        return $this->remainingTurns;
    }

    public function setRemainingTurns(int $remainingTurns): self
    {
        $this->remainingTurns = $remainingTurns;

        return $this;
    }

    public function getWastedTurns(): ?int
    {
        return $this->wastedTurns;
    }

    public function setWastedTurns(int $wastedTurns): self
    {
        $this->wastedTurns = $wastedTurns;

        return $this;
    }

    /**
     * @return Collection|Storage[]
     */
    public function getStorages(): Collection
    {
        return $this->storages;
    }

    public function findStorage(string $resourceName): ?Storage
    {
        foreach ($this->getStorages() as $storage) {
            if ($storage->getResource()->getName() === $resourceName) {
                return $storage;
            }
        }

        return null;
    }

    public function addStorage(Storage $storage): self
    {
        if (!$this->storages->contains($storage)) {
            $this->storages[] = $storage;
            $storage->setCity($this);
        }

        return $this;
    }

    public function removeStorage(Storage $storage): self
    {
        // set the owning side to null (unless already changed)
        if ($this->storages->removeElement($storage) && $storage->getCity() === $this) {
            $storage->setCity(null);
        }

        return $this;
    }

    public function getStorageCount(string $resourceName): int // TODO : Maybe optimize ?
    {
        $storage = $this->findStorage($resourceName);
        if ($storage instanceof Storage) {
            return $storage->getAmount();
        }

        return 0;
    }

    public function getPopulationCount(): int
    {
        $count = 0;
        foreach ($this->storages as $storage) {
            if ('population' !== $storage->getResource()->getResourceType()) {
                continue;
            }
            $count += $storage->getAmount();
        }

        return $count;
    }

    public function getUnitCount(string $resourceName): int
    {
        return $this->getDefense()->getUnitCount($resourceName);
    }

    /**
     * @return Collection|BuiltBuildings[]
     */
    public function getBuiltBuildings(): Collection
    {
        return $this->builtBuildings;
    }

    public function addBuiltBuilding(BuiltBuildings $builtBuilding): self
    {
        if (!$this->builtBuildings->contains($builtBuilding)) {
            $this->builtBuildings[] = $builtBuilding;
            $builtBuilding->setCity($this);
        }

        return $this;
    }

    public function removeBuiltBuilding(BuiltBuildings $builtBuilding): self
    {
        // set the owning side to null (unless already changed)
        if ($this->builtBuildings->removeElement($builtBuilding) && $builtBuilding->getCity() === $this) {
            $builtBuilding->setCity(null);
        }

        return $this;
    }

    public function getBuildingLevel(string $buildingName): int
    {
        foreach ($this->builtBuildings as $builtBuilding) {
            if ($builtBuilding->getBuilding()->getName() !== $buildingName) {
                continue;
            }

            return $builtBuilding->getLevel();
        }

        return 0;
    }

    public function isRecruiting(): ?bool
    {
        return $this->recruiting;
    }

    public function setRecruiting(bool $recruiting): self
    {
        $this->recruiting = $recruiting;

        return $this;
    }

    public function getConstructionProject(): ?Constructions
    {
        return $this->constructionProject;
    }

    public function setConstructionProject(?Constructions $constructionProject): self
    {
        $this->constructionProject = $constructionProject;

        return $this;
    }

    public function getProjectLevel(): ?int
    {
        return $this->projectLevel;
    }

    public function setProjectLevel(?int $projectLevel): self
    {
        $this->projectLevel = $projectLevel;

        return $this;
    }

    public function getNode(): WorldMapNode
    {
        if (is_null($this->node)) {
            throw new \LogicException('A city need a node');
        }

        return $this->node;
    }

    public function setNode(WorldMapNode $node): self
    {
        $this->node = $node;

        return $this;
    }

    public function getFreeUnitCount(): int
    {
        $freeUnits = [0, 5, 10, 20, 50, 100];

        return $freeUnits[$this->getBuildingLevel('barracks')];
    }

    public function getDungeonLevel(): int
    {
        return $this->dungeonLevel;
    }

    public function getHousesCount(): int
    {
        return $this->housesCount;
    }

    public function increaseDungeonLevel(): self
    {
        ++$this->dungeonLevel;
        $this->housesCount = 0;

        return $this;
    }

    public function decreaseDungeonLevel(): self
    {
        --$this->dungeonLevel;
        $this->housesCount = 0;

        return $this;
    }

    public function addHouses(int $nbHouses): self
    {
        $this->housesCount += $nbHouses;
        if ($this->housesCount < 0) {
            $this->housesCount = 0;
        }

        return $this;
    }

    public function getDefense(): ArmyContainer
    {
        return $this->defense;
    }

    public function setDefense(ArmyContainer $defense): void
    {
        $this->defense = $defense;
    }
}

EternalKingdom/src/Entity/General.php
<?php

namespace App\Entity;

use App\Entity\Battle\Battle;
use App\Entity\World\MovementOrder;
use App\Entity\World\WorldMapNode;
use App\Repository\GeneralRepository;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=GeneralRepository::class)
 */
class General implements \JsonSerializable
{
    /**
     * @ORM\Id
     *
     * @ORM\GeneratedValue
     *
     * @ORM\Column(type="integer")
     */
    private int $id;

    /**
     * @ORM\ManyToOne(targetEntity=Lord::class, inversedBy="generals")
     *
     * @ORM\JoinColumn(nullable=false)
     */
    private Lord $owner;

    /**
     * @ORM\Column(type="integer")
     */
    private int $reputation = 1;

    /**
     * @ORM\OneToOne(targetEntity=ArmyContainer::class, cascade={"persist", "remove"})
     *
     * @ORM\JoinColumn(nullable=false)
     */
    private ArmyContainer $armyContainer;

    /**
     * @ORM\Column(type="boolean")
     */
    private bool $fortifying = false;

    /**
     * Does the general is moving right now?
     *
     * @ORM\OneToOne(targetEntity=MovementOrder::class, mappedBy="instigator")
     *
     * @ORM\JoinColumn(nullable=true)
     */
    private ?MovementOrder $movementOrder = null;

    /**
     * Does the general is participating in a Battle right now?
     *
     * @ORM\ManyToOne(targetEntity=Battle::class, inversedBy="engagedGenerals")
     *
     * @ORM\JoinColumn(nullable=true)
     */
    private ?Battle $battle = null;

    /**
     * @ORM\Column(type="string", length=50)
     */
    private string $name;
    /**
     * Current location on the world map.
     *
     * @ORM\ManyToOne(targetEntity=WorldMapNode::class, inversedBy="generals")
     *
     * @ORM\JoinColumn(nullable=false)
     */
    private WorldMapNode $location;

    public function __construct(
        string $name,
        WorldMapNode $location,
    ) {
        $this->armyContainer = new ArmyContainer();
        $this->name = $name;
        $this->location = $location;
    }

    #[\Override]
    public function jsonSerialize(): array
    {
        return [
            'id' => $this->id,
            'ownerId' => $this->owner->getId(),
            'name' => $this->name,
            'locationName' => $this->location->getData()->getName(),
            'reputation' => $this->reputation,
            'isFortifying' => $this->fortifying,
            'movementOrder' => $this->movementOrder,
            'isAttacking' => null != $this->battle,
        ];
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getOwner(): ?Lord
    {
        return $this->owner;
    }

    public function setOwner(?Lord $owner): self
    {
        $this->owner = $owner;

        return $this;
    }

    public function getName(): ?string
    {
        return $this->name;
    }

    public function setName(string $name): self
    {
        $this->name = $name;

        return $this;
    }

    public function getReputation(): ?int
    {
        return $this->reputation;
    }

    public function setReputation(int $reputation): self
    {
        $this->reputation = $reputation;

        return $this;
    }

    public function getArmyContainer(): ?ArmyContainer
    {
        return $this->armyContainer;
    }

    public function setArmyContainer(ArmyContainer $armyContainer): self
    {
        $this->armyContainer = $armyContainer;

        return $this;
    }

    public function getLocation(): WorldMapNode
    {
        return $this->location;
    }

    public function setLocation(WorldMapNode $destination): self
    {
        $this->location = $destination;

        return $this;
    }

    public function isFortifying(): ?bool
    {
        return $this->fortifying;
    }

    public function setFortifying(bool $fortifying): self
    {
        $this->fortifying = $fortifying;

        return $this;
    }

    public function hasAnArmy(): bool
    {
        return $this->armyContainer->hasAnyUnits();
    }

    public function getArmyCost(): int
    {
        return max(0, $this->getArmyContainer()->getTotalUnitCount() - $this->getReputation());
    }

    public function getMovementOrder(): ?MovementOrder
    {
        return $this->movementOrder;
    }

    public function setMovementOrder(?MovementOrder $currentMovementOrder): void
    {
        $this->movementOrder = $currentMovementOrder;
    }

    public function getBattle(): ?Battle
    {
        return $this->battle;
    }

    public function setBattle(?Battle $battle): void
    {
        $this->battle = $battle;
    }
}

EternalKingdom/src/Controller/ManagementController.php
<?php

// src/Controller/ManagementController.php

namespace App\Controller;

use App\Entity\LogSystem\KingdomLog;
use App\Entity\Lord;
use App\Entity\Relation;
use App\Entity\User;
use App\Entity\World\ResourceSpot;
use App\Repository\LogSystem\KingdomLogRepository;
use App\Repository\RelationRepository;
use App\Repository\World\ResourceSpotRepository;
use Doctrine\Persistence\ManagerRegistry;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * ManagementController will display the Management page
 * Inspect how you are, your cities, your relations with other realms, your productions, ...
 */
class ManagementController extends AbstractController
{
    public function __construct(
        private readonly ManagerRegistry $managerRegistry
    ) {
    }

    /**
     * Lord Management page
     * Forwarded from DefaultController when accessing index webpage.
     *
     * @Route("/management/{tab}")
     */
    public function Management($tab = 'generals'): Response
    {
        /** @var User $user */
        $user = $this->getUser();
        if (null === $user) {
            return $this->redirectToRoute('homepage');
        }

        if (null !== $user->getLord() && $user->getLord()->isAlive()) {
            /** @var RelationRepository $relationsRepository */
            $relationsRepository = $this->managerRegistry->GetRepository(Relation::class);
            $relations = $relationsRepository->findBy(['lord' => $user->getLord()]);

            return $this->generateManagementResponse($tab, ['relations' => $relations]);
        }

        return $this->redirectToRoute('homepage');
    }

    /**
     * Lord Management page
     * Forwarded from DefaultController when accessing index webpage.
     *
     * @Route("/management/diplomacy/invert")
     */
    public function invertDiplomacy(): Response
    {
        /** @var User $user */
        $user = $this->getUser();
        if (null === $user) {
            return $this->redirectToRoute('homepage');
        }

        if (null !== $user->getLord() && $user->getLord()->isAlive()) {
            /** @var RelationRepository $relationsRepository */
            $relationsRepository = $this->managerRegistry->GetRepository(Relation::class);
            $relations = $relationsRepository->findBy(['target' => $user->getLord()]);

            $params = [
                'relations' => $relations,
                'isDiplomacyInverted' => true,
            ];

            return $this->generateManagementResponse('diplomacy', $params);
        }

        return $this->redirectToRoute('homepage');
    }

    /**
     * @param string $tab Generals, Vassals, Kingdom or Diplomacy
     */
    private function generateManagementResponse(string $tab, array $extraParameters = []): Response
    {
        /** @var User $user */
        $user = $this->getUser();
        if (null === $user) {
            return $this->redirectToRoute('homepage');
        }

        if (null !== $user->getLord() && $user->getLord()->isAlive()) {
            $lord = $user->getLord();

            /** @var KingdomLogRepository $kingdomLogsRepository */
            $kingdomLogsRepository = $this->managerRegistry->GetRepository(KingdomLog::class);
            $kingdomLogs = $kingdomLogsRepository->findBy(['lord' => $lord], ['timestamp' => 'DESC', 'id' => 'ASC']);

            /** @var ResourceSpotRepository $resourceSpotRepository */
            $resourceSpotRepository = $this->managerRegistry->GetRepository(ResourceSpot::class);
            $resourceSpots = $resourceSpotRepository->findOwnedResourceSpot($lord);

            $commonParameters = [
                'lord' => $lord,
                'resourceSpots' => $resourceSpots,
                'logs' => $kingdomLogs,
                'tab' => $tab,
            ];
            $allParameters = array_merge($commonParameters, $extraParameters);

            return $this->render('Management/management.html.twig', $allParameters);
        }

        return $this->redirectToRoute('homepage');
    }
}

EternalKingdom/templates/Management/Components/GeneralsTab.html.twig
{% trans_default_domain 'Management' %}

<script>
    let timer = null;
</script>

<div id="generals" style="display: none; overflow:auto; ">
    {% if (lord.generals|length) == 0 %}
        <p class="nothing">
            {{ 'tabs.generals.noGeneral' | trans }}
            {% if lord.city.buildingLevel('headquarters') > 0 %}
                    <ul class="actions" style="margin-left:200px;">
                        {% include 'Components/RecruitGeneralButton.html.twig' %}
                    </ul>
            {% else %}
                {{ 'tabs.generals.noHeadQuarters' | trans }}
            {% endif %}
        </p>
    {% else %}
        <table class="blocks">
            <tbody>
            <tr>
                {% set generalCount = 0 %}
                {% for general in lord.generals %}  
                    {% if generalCount%3 == 0 %}
                    </tr> <tr>
                    {% endif %}
                    {% set generalCount = generalCount+1 %}
                    <td>
                        <div class="blocks_top">
                            <h3 class="h3c">
                                {% set generalCssClass = "gdef" %}
                                {% if general.movementOrder %}
                                    {% set generalCssClass = "gmove" %}
                                {% elseif general.isFortifying %}
                                    {% set generalCssClass = "gfortify" %}
                                {% elseif general.battle != null %}
                                    {% set generalCssClass = "gbattle" %}
                                {% endif %}
                                <p class="{{ generalCssClass }}">
                                    <a href="{{ path('app_map_focusGeneral', {'worldId': lord.worldmap.id, 'generalId': general.id })}}">{{ general.name }}</a>
                                </p>
                            </h3>
                            <div class="blocks_bg">
                                <div class="blocks_bottom">
                                    <div class="p">
                                        {% if general.movementOrder %}
                                            {{ 'tabs.generals.state.movingTo' | trans(
                                                {
                                                    '%originLink%' : path('app_map_focusNode', {'worldId': lord.worldmap.id, 'nodeId': general.movementOrder.origin.id }),
                                                    '%originName%' : general.movementOrder.origin.name,
                                                    '%destinationLink%' : path('app_map_focusNode', {'worldId': lord.worldmap.id, 'nodeId': general.movementOrder.destination.id }),
                                                    '%destinationName%' : general.movementOrder.destination.name
                                                }) | raw
                                            }}
                                            <div>
                                                <script type="text/javascript">
                                                    let movementEndDate = "{{ general.movementOrder.travelEndDateAsString() }}";
                                                    updateTimer(movementEndDate, null);
                                                </script>
                                            </div>
                                        {% elseif general.battle != null %}
                                            {# TODO Display if the general is attacking or defending (just add a parameter?) #}
                                            {{ 'tabs.generals.state.attacking' | trans(
                                                {
                                                    '%battleLink%' : path('app_battle_battleindex', {'id': general.battle.id }),
                                                    '%locationName%' : general.location.name
                                                }) | raw
                                            }}
                                        {% elseif general.isFortifying %}
                                            {{ 'tabs.generals.state.fortifying' | trans }} <a href="{{ path('app_map_focusNode', {'worldId': lord.worldmap.id, 'nodeId': general.location.id })}}">{{ general.location.name }}</a>
                                        {% else %}
                                            {{ 'tabs.generals.state.waitingAt' | trans }} <a href="{{ path('app_map_focusNode', {'worldId': lord.worldmap.id, 'nodeId': general.location.id })}}">{{ general.location.name }}</a>
                                        {% endif %}
                                    </div>
                                    <p>
                                        <img src="{{ asset('img/help.gif') }}"
                                            class="help"
                                            onmouseover="showHint(this,'{{ 'tabs.generals.reputation' | trans }}','{{ 'tabs.generals.reputationTooltip' | trans }}')"
                                            onmouseout="hideHint()">
                                        <span class="dt">{{ 'tabs.generals.reputation' | trans }}</span> :
                                            <strong>{{ general.reputation }}</strong> 
                                        <img src="{{ asset('img/icons/l_rep.png') }}">
                                    </p>
                                    <p>
                                        <img src="{{ asset('img/help.gif') }}"
                                            class="help"
                                            onmouseover="showHint(this,'{{ 'tabs.generals.maintenance' | trans }}','{{ 'tabs.generals.maintenanceTooltip' | trans }}')"
                                            onmouseout="hideHint()">
                                        <span class="dt">{{ 'tabs.generals.maintenance' | trans }}</span> :
                                            <strong>{{ general.armyCost }}</strong>
                                            <img src="{{ asset('img/icons/small/res_gold.gif') }}">
                                    </p>

                                    <ul class="ismall">
                                        {% for army in general.armyContainer.units %}
                                            {% set unitName = army.resource.name %}
                                            <li>
                                                <div class=""
                                                    onmouseover="showHint(this,'{{ ('units.'~unitName~'.name') | trans([], 'Common') }}','{{ ('units.'~unitName~'.desc') | trans([], 'Common') }}')"
                                                    onmouseout="hideHint()">
                                                    <img src="{{ asset('img/icons/small/u_'~army.resource.name~'.gif') }}" alt="">
                                                    <span class="number">{{ army.amount }}</span>
                                                </div>
                                            </li>
                                        {% endfor %}
                                    </ul>
                                    <div class="clear"></div>
                                </div>
                            </div>
                        </div>
                    </td>
                {% endfor %}
                {% if generalCount%3 == 0 %}
                    </tr> <tr>
                {% endif %}
                {% if lord.city.buildingLevel('headquarters') > lord.generals|length %}
                    <td>
                        <div class="blocks_top">
                            <ul class="actions" style="margin-left: 8px">
                                {% include 'Components/RecruitGeneralButton.html.twig' %}
                            </ul>
                        </div>
                    </td>
                {% endif %}
            </tr>
            </tbody>
        </table>
    {% endif %}
</div>


{# WHEN MOVING
<td>
									<div class="blocks_top">
										<h3 class="h3c">
											<p class="gmove">
												<a href="/map?g=1521641">symfony</a>
											</p>
										</h3>
										<div class="blocks_bg">
											<div class="blocks_bottom">
												<div class="p">
													Se déplace entre <a href="/map?c=794410">Les Toromos-les-Guibain</a> et <a href="/map?c=794450">Annomoi</a>
													<div>
                                                        <script type="text/javascript">
                                                        mt.js.Timer.TIMES="jhms";
                                                        mt.js.Timer.alloc('2021-11-06 12:18:36','2021-11-06 13:23:27',2,null);
                                                        </script>
                                                        <div id="timer_0" class="timer">1h 03m </div>
													</div>
												</div>
											<p>
#}

EternalKingdom/templates/Management/Components/LordInfo.html.twig
{% trans_default_domain 'Management' %}

<ul>
	<li>
	    <img src="{{ asset('img/help.gif') }}" class="help" alt="hint"
			 onmouseover="showHint(this,'{{ 'stats.title.name' | trans }}','{{ 'stats.title.desc' | trans }}')"
			 onmouseout="hideHint()">
        <span class="dt">{{ 'stats.title.name' | trans }} :</span>
		<b>{{ ('lord.titles.'~lord.title.value) | trans([], 'Common') | capitalize }}</b>
	</li>

	<li>
		<img src="{{ asset('img/help.gif') }}" class="help" alt="hint"
			 onmouseover="showHint(this,'{{ ('stats.age.name') | trans }}','{{ ('stats.age.desc') | trans }}')"
			 onmouseout="hideHint()">
        <span class="dt">{{ ('stats.age.name') | trans }} :</span>
		<b>{{ 'lord.age' | trans({'%years%': lord.ageYear, '%months%': lord.ageMonth | round(0, 'floor') }, "Common") }}</b>
	</li>
	
    <li>
	<img src="{{ asset('img/help.gif') }}" class="help" alt="hint"
		 onmouseover="showHint(this,'{{ 'stats.health.name' | trans }}','{{ 'stats.health.desc' | trans }}')"
		 onmouseout="hideHint()">
    <span class="dt">{{ 'stats.health.name' | trans }} :</span>
	<b>{{ ('healths.'~lord.health) | trans }}</b>
	</li>
	
    <li>
	    <img src="{{ asset('img/help.gif') }}" class="help" alt="hint"
			 onmouseover="showHint(this,'{{ 'stats.glory.name' | trans }}','{{ 'stats.glory.desc' | trans }}')"
			 onmouseout="hideHint()">
        <span class="dt">{{ 'stats.glory.name' | trans }} :</span>
	    <b><strong>{{ lord.glory }}</strong> <img src="{{ asset('img/icons/l_up.png') }}" alt="level up"></b>
	</li>
	
    <li>
		<img src="{{ asset('img/help.gif') }}" class="help" alt="hint"
			 onmouseover="showHint(this,'{{ 'stats.maxGlory.name' | trans }}','{{ 'stats.maxGlory.desc' | trans }}')"
			 onmouseout="hideHint()">
        <span class="dt">{{ 'stats.maxGlory.name' | trans }} :</span>
		<b><strong>{{ lord.maxGlory }}</strong> <img src="{{ asset('img/icons/l_up.png') }}" alt="level up"></b>
	</li>
										
    <li>
	    <img src="{{ asset('img/help.gif') }}" class="help" alt="hint"
			 onmouseover="showHint(this,'{{ 'stats.trade.name' | trans }}','{{ 'stats.trade.desc' | trans }}')"
			 onmouseout="hideHint()">
        <span class="dt">{{ 'stats.trade.name' | trans }} :</span>
		<b><strong>{{ lord.trade }}</strong> <img src="{{ asset('img/icons/small/res_gold.gif') }}" alt="gold"></b>
	</li>
</ul>

EternalKingdom/templates/Management/Components/VassalsTab.html.twig
<div id="vassals" style="">
    <p class="nothing">
        {{  'messages.comingSoon' | trans([], 'Common') }}
        {# TODO Implement Vassalization
        {{ 'tabs.vassals.noVassal' | trans([], 'Management') }}
        #}
    </p>
    <table class="blocks">
        <tbody>
        <tr>
            {#
            {% for vassal in lord.vassals %}
                <td>
                    <div class="blocks_top">
                        <h3 class="h3c">
                            <a href="">{{ vassal.name }}</a>  
                        </h3>
                        <div class="blocks_bg">
                            <div class="blocks_bottom">
                                <p><span class="dt">{{ stats.title.name | trans([], 'Management') }}</span> : {{ vassal.title | trans([], 'Management') }}</p>
                                <p>
                                    <span class="dt">{{ stats.glory.name | trans([], 'Management') }}</span> : <strong>{{ vassal.glory }}</strong> 
                                    <img src="{{ asset('img/icons/l_up.png') }}">
                                </p>
                                <p>
                                    <span class="dt">{{ tabs.vassals.taxes | trans([], 'Management') }}</span> : <strong>2</strong>  TODO DETECT TAXES
                                    <img src="{{ asset('img/icons/Small/res_gold.gif') }}">
                                    (20%)
                                </p>
                                <p>
                                    <span class="dt">{{ tabs.vassals.taxesToCollect | trans([], 'Management') }}</span> : <strong>27</strong>  TODO DETECT TAXES
                                    <img src="{{ asset('img/icons/Small/res_gold.gif') }}">
                                    <a href="*">{{ tabs.vassals.collect | trans([], 'Management') }}</a> TODO IMPLEMENT ROUTE REQUEST 
                                </p>

                            </div>
                        </div>
                    </div>
                </td>
            {% endfor %}
            #}
        </tr>
        </tbody>
    </table>
</div>